# AnotherLevelUp/fvwm2rc.menus.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999 and Red Hat Software, Inc


divert(-1)
# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.menus.m4,v 1.11 1999/04/05 18:31:57 notting Exp $	
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

###########################################################################
#
# Now create the menus
#

#JTL#This builds the favourites menu and the wmconfig programs menu
TraceForErrors(`Favourites menu...')
readFile(`fvwm2rc.favourites')


TraceForErrors(`Basic start menu...')

define(`IfHostsDefined', `
ifdef(`USER_HOST_LIST', `$1', ifdef(`AUTO_HOST_MENU', `$1'))
')


#JTL: no longer used - what was the point anyway? Now done as MenuAndButtonEntryLM
# This is for the Start menu of the FvwmTaskBar
#define(`BasicStartMenu',`dnl
##JTL#+ "&New shell MiniTitleIcon(sh1)"        	Exec  XTERM
#+ "New &Shell MiniTitleIcon(sh1)"        	Exec  XTERM
##JTL#
#ifdef(`XEDITOR', `+ "New &Editor MiniTitleIcon(edit)" Exec XEDITOR')
#+ "New &Netscape MiniTitleIcon(nscape)"		Exec  NETSCAPE
##JTL#
#+ "&Gnome Browser MiniTitleIcon(filemgr)"	Popup ToggleGMC
##JTL#
#+ "" Nop
##JTL#
#ifdef(`USER_MENU', `
#+ "&User menu"					Popup UserMenu
#')
#+ "&Help tool MiniTitleIcon(question)"     Exec helptool
#+ "Calendar / &Diary MiniTitleIcon(clipboard)"  Exec  XCAL
#changecom
#+ "&Calculator MiniTitleIcon(calc)"             Exec xcalc -bg "FMBG_COLOR" -fg "FMFG_COLOR" -stipple
#changecom(#)
##JTL#
#+ "" Nop
##JTL#
##JTL#+ "&Programs MiniTitleIcon(penguin)"	Popup ROOT_MENU
#+ "&Other Programs MiniTitleIcon(penguin)"	Popup ROOT_MENU
#')

#JTL#
ifdef(`USER_MENU', `AddToMenu UserMenu' USER_MENU)

#JTL#AddToMenu StartMenu "Start MiniTitleIcon(shadowman)" Title
AddNewMenuAndButtonBar(StartMenu, "Start MiniTitleIcon(modules) (Vn: JTL_RELEASE)")

#JTL#The above BasicStartMenu is here as MenuAndButtonEntryLM entries
MenuAndButtonEntryLM(New &Shell,sh1,,Exec  XTERM)
ifdef(`XEDITOR', `MenuAndButtonEntryLM(New &Editor,edit,,Exec XEDITOR)')
MenuAndButtonEntryLM(New &Netscape,nscape,,Exec  NETSCAPE)
IfProgramExists(`gmc', `
MenuAndButtonEntryLM(&Gnome Browser,filemgr,,Popup ToggleGMC)
')

ifdef(`HostSpecificStartMenu', HostSpecificStartMenu)

AddToMenu StartMenu
+ "" Nop
#JTL
MenuAndButtonEntryLM(&Favourites,run,,Function CreateAndPopupFavouritesMenu)

ifdef(`USER_MENU', `MenuAndButtonEntryLM(User &menu,run,,Popup UserMenu)')

#JTL
AddToMenu StartMenu
+ "" Nop

MenuAndButtonEntryLM(&Help tool,question,,Exec helptool)
MenuAndButtonEntryLM(Calendar / &Diary,clipboard,,Exec  XCAL)
changecom
MenuAndButtonEntryLM(&Calculator,calc,,Exec xcalc -bg "FMBG_COLOR" -fg "FMFG_COLOR" -stipple)
changecom(#)
IfProgramExists(`ddd', `
MenuAndButtonEntryLM(D&ebugger (ddd),roach,,Exec ddd)
')
AddToMenu StartMenu
+ "" Nop
MenuAndButtonEntryLM(&Other Programs,penguin,penguin,Popup ROOT_MENU)

#JTL#BasicStartMenu

# seek for big applications already on disk...
readFile(`fvwm2rc.apps')

#JTL#The following has now all been moved to fvwm2rc.favourites.m4
#AddToMenu ROOT_MENU "Programs MiniTitleIcon(penguin)" Title
#
## AUTOMATIC MENU generation - begin
#define(`WMCONFIG_1', `')
#define(`WMCONFIG_2', `')
#ifdef(`MINI_ICONS', `', `define(`WMCONFIG_1', `--no-mini-icons')')
#ifdef(`NO_ICONS', `define(`WMCONFIG_2', `--no-icons')')
#changecom(%%%)
## wmconfig --output=fvwm2 --rootmenu="ROOT_MENU" WMCONFIG_1 WMCONFIG_2
#changecom(#)
#esyscmd(wmconfig --output=fvwm2 --rootmenu="ROOT_MENU" WMCONFIG_1 WMCONFIG_2 2>/dev/null)
## AUTOMATIC MENU generation - end

AddToMenu StartMenu
+ "" Nop
#JTL
ifdef(`WANT_NETWORK_CONNECTIONS', `MenuAndButtonEntryLM(Net&work Connections,telnet,,PipeRead "ANOTHERLEVEL/bin/network-connections NETWORK_CONNECTIONS_HOST")')
#JTL#IfHostsDefined(`+ "H&osts MiniTitleIcon(windows)"		Popup Hosts')
IfHostsDefined(`MenuAndButtonEntryLM(H&osts,windows,,Popup Hosts)')
#JTL
MenuAndButtonEntryLM(&Preferences,prefs,,Popup Preferences)
#JTL#+ "&System Utilities MiniTitleIcon(connect)"	Popup SystemUtilities
MenuAndButtonEntryLM(System &Utilities,connect,,Popup SystemUtilities)
#JTL#+ "&Preferences MiniTitleIcon(prefs)" 		Popup "Preferences"
#JTL#+ "&Window Operations MiniTitleIcon(windows)"	Popup Window-Ops
MenuAndButtonEntryLM(&Window Operations,windows,,Popup Window-Ops)
AddToMenu StartMenu
+ "" Nop

#JTL#Make fvwm2rc.xlock configurable, so can be used to make
#JTL#moving background menu too
define(`XLOCKFORMNAME', `XLock')
define(`XLOCKLOCKSCREEN')
undefine(`XLOCKBACKGROUND')
readFile(`forms_Xlock')
ifdef(`XLockScreenUserChoice', `
define(`XLockUserChoice', XLockScreenUserChoice)
')
readFile(`fvwm2rc.xlock')

#JTL#The lines below used to be in fvwm2rc.xlock
AddToMenu StartMenu
#JTL#+ "Lock Screen / Screen Saver MiniTitleIcon(lock)"     FvwmForm XLOCKFORMNAME
MenuAndButtonEntryLM(&Lock Screen,lock,,FvwmForm XLOCKFORMNAME)
AddToMenu StartMenu
+ "" Nop


#JTL#AddToMenu StartMenu
#JTL#+ "A&bout Fvwm MiniTitleIcon(exclam)"		FvwmForm About
MenuAndButtonEntryLM(A&bout Fvwm,exclam,,FvwmForm About)
AddToMenu StartMenu
+ "" Nop

#ifdef(`BROWSER_HELP_COMMAND',`
#AddToMenu StartMenu "&Help Fvwm MiniTitleIcon(question)" Exec BROWSER_HELP_COMMAND
#+ "" Nop
#')

#JTL#AddToMenu StartMenu "E&xit Fvwm MiniTitleIcon(stop)"	Popup Quit-Verify
MenuAndButtonEntryLM(E&xit Fvwm,stop,,Popup Quit-Verify)

AddToMenu "Quit-Verify" "Really Quit Fvwm?" Title
#JTL#+ "&Restart MiniTitleIcon(turn)"		Restart FVWM_BIN_NAME
#JTL#+ ""						Nop
#JTL#+ "&Switch To... MiniTitleIcon(windows)"	Popup WindowManagers
#JTL#+ ""						Nop
#JTL#+ "&No, Don't Quit MiniTitleIcon(cross)" 	Nop
#JTL#+ "&Yes, Really Quit MiniTitleIcon(exclam)"	ifdef(`NO_VERIFY_QUIT',`Quit',`FvwmForm LogoutVerify')
+ "&No, Don't Quit MiniTitleIcon(cross)" 	Nop
+ "&Yes, Really Quit MiniTitleIcon(exclam)"	ifdef(`NO_VERIFY_QUIT',`Quit',`FvwmForm LogoutVerify')
+ ""						Nop
#JTL#+ "&Restart MiniTitleIcon(turn)"		Restart FVWM_BIN_NAME
+ "&Restart MiniTitleIcon(turn)"		Function ReallyRestart
+ "Restart &Programs MiniTitleIcon(turn)"	StartupFunction
+ ""						Nop
+ "&Switch To... MiniTitleIcon(windows)"	Popup WindowManagers
IfProgramExists(`/usr/bin/shutdown', `
+ "Shutdown &Halt MiniTitleIcon(stop)"		Exec /usr/bin/shutdown -h now
+ "Shutdown Re&boot MiniTitleIcon(turn)"	Exec /usr/bin/shutdown -r now
')

#JTL#Do we need this?
AddToMenu ScrollPreferences "Change Scroll Behavior" Title
+ "&On"    		EdgeScroll 100 100
+ "O&ff"   		EdgeScroll 0 0
+ "&Horizontal Only"    EdgeScroll 100 0
+ "&Vertical Only"      EdgeScroll 0 100
+ "&Partial"        	EdgeScroll 50 50

#JTL#Whats is the point of this?
#AddToMenu Colours  "Color Settings" Title
#+ "Color &Map"       Exec xcmap
#+ "&Reset Color Map" Exec xstdcmap -default

#JTL#
define(`XLOCKFORMNAME', `MovingBackground')
undefine(`XLOCKLOCKSCREEN')
define(`XLOCKBACKGROUND')
define(`XLockUserChoice', BG_MOVING)
readFile(`fvwm2rc.xlock')

#JTL#
AddToMenu Background "Set Root Background" Title
+ "&Static (solid, mixture or image; and frame colour) MiniTitleIcon(rainbow)" FvwmScript ScreenSetup
+ "&Moving (xlock running on root window) MiniTitleIcon(hextris)" FvwmForm XLOCKFORMNAME
+ "&XSnow (with or without santa) MiniTitleIcon(xsnow)" FvwmScript XSnow
+ "X&Eyes (eyes that follow the mouse) MiniTitleIcon(eyes)" FvwmScript XEyes
+ "XE&arth (earth seen from space) MiniTitleIcon(clock)" FvwmScript XEarth

AddToFunc SetRootCursor "I" Exec xsetroot -cursor_name $0


AddToMenu RootCursor "Set Root Cursor" Title
+ "&Reset to X_cursor" SetRootCursor X_cursor
+ "&Miscellany" Popup MiscellanyCursors
+ "&Arrows" Popup ArrowCursors
+ "Cor&ners" Popup CornersCursors
+ "&Crosses" Popup CrossesCursors
+ "&Objects" Popup ObjectsCursors

#AddCursorToMenu($1=Menu,$2=Cursor)
define(`AddCursorToMenu',`
AddToMenu $1 "$2" SetRootCursor $2')

foreach(`x',
`(arrow,based_arrow_down,based_arrow_up,double_arrow,question_arrow,sb_down_arrow,sb_h_double_arrow,sb_left_arrow,sb_right_arrow,sb_up_arrow,sb_v_double_arrow,top_left_arrow)',
`AddCursorToMenu(ArrowCursors,x)')

foreach(`x',
`(top_left_corner,top_side,top_right_corner,left_side,right_side,bottom_left_corner,bottom_side,bottom_right_corner)',
`AddCursorToMenu(CornersCursors,x)')

foreach(`x',
`(X_cursor,cross,cross_reverse,crosshair,diamond_cross,iron_cross,tcross)',
`AddCursorToMenu(CrossesCursors,x)')

foreach(`x',
`(boat,bogosity,box_spiral,circle,clock,coffee_mug,dot,dotbox,draft_large,draft_small,draped_box,exchange,fleur,gobbler,gumby,hand1,hand2,heart,icon,man,mouse,num_glyphs,pencil,pirate,plus,rtl_logo,sailboat,shuttle,spider,spraycan,star,target,trek,umbrella,watch)',
`AddCursorToMenu(ObjectsCursors,x)')

foreach(`x',
`(bottom_tee,left_tee,leftbutton,ll_angle,lr_angle,ul_angle,ur_angle,middlebutton,right_tee,rightbutton,top_tee)',
`AddCursorToMenu(TeesButtonsAnglesCursors,x)')

foreach(`x',
`(center_ptr,left_ptr,right_ptr,sizing,xterm)',
`AddCursorToMenu(MiscellanyCursors,x)')

divert(-1)
#foreach(`x',
#`(X_cursor,arrow,based_arrow_down,based_arrow_up,boat,bogosity,
#bottom_left_corner,bottom_right_corner,bottom_side,bottom_tee,
#box_spiral,center_ptr,circle,clock,coffee_mug,cross,cross_reverse,crosshair,
#diamond_cross,dot,dotbox,double_arrow,draft_large,draft_small,draped_box,
#exchange,fleur,gobbler,gumby,hand1,hand2,heart,icon,iron_cross,left_ptr,
#left_side,left_tee,leftbutton,ll_angle,lr_angle,man,middlebutton,mouse,num_glyphs,
#pencil,pirate,plus,question_arrow,right_ptr,right_side,right_tee,rightbutton,
#rtl_logo,sailboat,sb_down_arrow,sb_h_double_arrow,sb_left_arrow,sb_right_arrow,
#sb_up_arrow,sb_v_double_arrow,shuttle,sizing,spider,spraycan,star,target,tcross,
#top_left_arrow,top_left_corner,top_right_corner,top_side,top_tee,trek,ul_angle,
#umbrella,ur_angle,watch,xterm)',
#`AddCursorToMenu(AllCursorsMenu,x)')
divert

AddToFunc Speed "I" Exec xset m $0

AddToMenu MouseSettings "Mouse Settings" Title
+ "&1 Ultra Fastest" 	Speed "20 5"
+ "&2 Next Fastest"  	Speed "15 6"
+ "&3 Faster"	  	Speed "10 7"
+ "&4 Fast"	  	Speed "7 8"
+ "&5 Normal"	  	Speed "5 10"
+ "&6 Slower"	  	Speed "default"
+ "&N No acceleration"  Speed "0 10000"
+ "" Nop
+ "&Right Handed (1 2 3)" Exec xmodmap -e "pointer = 1 2 3"
+ "&Left Handed (3 2 1)" Exec xmodmap -e "pointer = 3 2 1"

AddToFunc AutoRaiseSpeed 
+ "I" KillModule FvwmAuto
+ "I" FvwmAuto $0
+ "I" Exec `echo "define(\`AUTO_RAISE_SPEED', '$0`)" > .fvwm2dir/menu_AutoRaise'

#JTL#define(`AddAutoRaiseSpeed',`+ "&$1 ms" Function AutoRaiseSpeed $1
define(`AddAutoRaiseSpeed',`+ "$1 ms" Function AutoRaiseSpeed NoAmpersands($1)
')

#JTL#
AddToFunc AutoRaiseOff
+ "I" KillModule FvwmAuto
+ "I" Exec `echo "undefine(\`USE_AUTO_RAISE')" > .fvwm2dir/menu_AutoRaise'


#JTL#AddToMenu AutoRaiseMenu "AutoRaise" Title
AddToMenu AutoRaiseMenu "Auto Raise" Title
#JTL#+ "O&ff" KillModule FvwmAuto
+ "O&ff" AutoRaiseOff
+ "" Nop

#JTL#foreach(x,`(0,200,400,500,1000,3000)',`AddAutoRaiseSpeed(x)')
foreach(x,`(&0,20&1,40&2,60&3,80&4,100&5,150&6,200&7,250&8,300&9)',`AddAutoRaiseSpeed(x)')

#JTL#Click to focus preferences
AddToFunc ClickToFocus
+ "I" Style "*" ClickToFocus
+ "I" Style "FvwmButtons" SloppyFocus
+ "I" Recapture
+ "I" Exec `echo "undefine(\`FOCUS_FOLLOWS_POINTER')" > .fvwm2dir/menu_WindowFocus'


AddToFunc AutoFocus
+ "I" Style "*" SloppyFocus
+ "I" Style "XCLOCKNAME" ClickToFocus
+ "I" Style "XBIFFNAME" ClickToFocus
+ "I" Style "xeyes" ClickToFocus
+ "I" Style "FvwmTaskBar" ClickToFocus
+ "I" Style "FvwmBanner" ClickToFocus
+ "I" Recapture
+ "I" Exec `echo "define(\`FOCUS_FOLLOWS_POINTER')" > .fvwm2dir/menu_WindowFocus'

AddToMenu WindowFocusMenu "Window Focus" Title
+ "&Click to focus" Function ClickToFocus
+ "&Auto focus" Function AutoFocus

#JTL#This menu was already not used, and not needed by us.
#AddToMenu AudioSettings "Audio Settings" Title
#+ "&On" Module FvwmAudio
#+ "O&ff" KillModule FvwmAudio
##+ "Event mapping" FvwmForm AudioEvents

#JTL#This needs some thought!
#AddToMenu XResources "X Resources" Title
#+ "&Load .Xdefaults" Exec xrdb -load .Xdefaults
#+ "&Merge .Xdefaults" Exec xrdb -merge .Xdefaults
#+ "L&oad .Xresources" Exec xrdb -load .Xresources
#+ "M&erge .Xresources" Exec xrdb -merge .Xresources
#+ "" Nop
#+ "&Display current settings" Exec StartNonInteractiveProgramInRxvt(`xrdb -query',XResources)


TraceForErrors(`Preferences menu...')

#JTL# No longer needed here - done as toggle function now
#AddToFunc Wharf
#+ "I"	KillModule FvwmButtons
#+ "I"	KillModule FvwmPager
#+ "I"	Module FvwmWharf

#JTL#
AddToFunc FvwmTaskBar
+ "I"	KillModule FvwmTaskBar
+ "I"	Module FvwmTaskBar

#JTL
ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-4.jpeg)
')

#JTL#
readFile(fvwm2rc.storedprefs)

#JTL
ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-5.jpeg)
')

AddNewMenuAndButtonBar(Preferences)
#JTL
ifelse(WM_STYLE, `FVWM95', `
MenuAndButtonEntryLM(Stored &Preferences, turn, turn, Popup StoredPreferences)
')
#JTL#MenuAndButtonEntryLM(&FvwmConfig,hammer,hammer_3d,Module FvwmConfig)
#JTL#
ifelse(SCREEN_SIZE, `Huge', `
MenuAndButtonEntryLM(&Initial Windows,windows,windows,FvwmScript InitialWindowsSetUp)
')
#JTL#MenuAndButtonEntryLM(&Background,colors,colors,FvwmScript ScreenSetup)
ifelse(WM_STYLE, `FVWM95', `
MenuAndButtonEntryLM(&Screen Background,colors,,Popup Background)
')
#JTL#
ifelse(WM_STYLE, `FVWM95', `
MenuAndButtonEntryLM(Window and Menu &Decorations,window,window,FvwmScript WindowDecorations)
')
ifelse(WM_STYLE, `FVWM95', `
MenuAndButtonEntryLM(Window &Buttons,xjewel,xjewel,FvwmScript WindowButtons)
')
#JTL#
ifelse(WM_STYLE, `FVWM95', `
MenuAndButtonEntryLM(&XTerm Preferences,term,term,FvwmScript Xresources_XTerm)
')
#JTL#
MenuAndButtonEntryLM(&Editor Choice,edit,edit,FvwmScript EditorChoice)
#JTL#
MenuAndButtonEntryLM(X&biff Preferences,xbiff,,FvwmScript XbiffChoice)
#JTL#
MenuAndButtonEntryLM(X &Clock Preferences,clock,,FvwmScript XclockChoice)
#JTL#
MenuAndButtonEntryLM(Pa&ger Settings,pager,,FvwmScript PagerSettings)
MenuAndButtonEntryLM(&Root Cursor,cross,,Popup RootCursor)
MenuAndButtonEntryLM(&Mouse,mouse,,Popup MouseSettings)
#JTL#MenuAndButtonEntryLM(&Colours,colors,,Popup Colours)
# MenuAndButtonEntryLM(A&udio,audiovol,Multimedia3,Popup AudioSettings)
#JTL
MenuAndButtonEntryLM(Window &Focus,eye,,Popup WindowFocusMenu)
#JTL#MenuAndButtonEntryLM(&AutoRaise,raise,hand_up_3d,Popup AutoRaiseMenu)
MenuAndButtonEntryLM(&Auto Raise,raise,hand_up_3d,Popup AutoRaiseMenu)
#JTL#MenuAndButtonEntryLM(&Scroll Setup,scroll-arrows,,Popup ScrollPreferences)
MenuAndButtonEntryLM(Scro&ll Setup,scroll-arrows,,Popup ScrollPreferences)
#JTL#MenuAndButtonEntryLM(&X Resources,x2,,Popup XResources)
IfProgramExists(`xkeycaps',`
MenuAndButtonEntryLM(&Keyboard layout,keys,,Exec xkeycaps)
')
#JTL#MenuAndButtonEntryLM(Save &Desktop to new.xinitrc,floppy,disk_3d,Module FvwmSave)

AddNewMenuAndButtonBar(SystemUtilities)
ifdef(`RH5', `
#JTL#DefineProgramLM(&Root shell,redhat,,StartProgramInColorXterm(sh -c su,Root_Window))
', `
#JTL#DefineProgramLM(&Root shell,shadowman-64,,StartProgramInColorXterm(sh -c su,Root_Window))
')
ifdef(`MESSAGE_LOG',`
MenuAndButtonEntryLM(&Msgs,doc,,Exec nice NICELEVEL RXVT -geometry 80x8+520-2 -T Msgs -fn SMALL_FONT -e nice NICELEVEL tail -8 -f MESSAGE_LOG)
')
MenuAndButtonEntryLM(T&op,run,,Exec RXVT -name top -T Top -n Top -e top)
MenuAndButtonEntryLM(&Identify Window,question,question,Module FvwmIdent)
DefineProgramLM(&Window Info,windows,,StartNonInteractiveProgramInRxvt(`xwininfo',WindowInfo))
#JTL#
MenuAndButtonEntryLM(&Console,term,,Popup ToggleConsole)
#JTL#MenuAndButtonEntryLM(&Talk Module,talk,,Module FvwmTalk)
#JTL#MenuAndButtonEntryLM(&Pager Module,pager,pages_3d,Module FvwmPager 0 1)
#JTL#MenuAndButtonEntryLM(&Pager Buttons,pager,pages_3d,Module FvwmButtons)
#JTL#MenuAndButtonEntryLM(Task &Bar,exp,,Module FvwmTaskBar)
ifdef(`RH5', `
', `
MenuAndButtonEntryLM(Reset Task &Bar,taskbar,, Function FvwmTaskBar)
')
#JTL#Moved from Window Operations
MenuAndButtonEntryLM(W&indow List Module,winlist,window3d,Module FvwmWinList)
#JTL#MenuAndButtonEntryLM(W&harf,pager,pages_3, Function Wharf)
MenuAndButtonEntryLM(W&harf,wharf,pages_3d, Popup ToggleWharf)
#JTL#
MenuAndButtonEntryLM(&Pager,pager,pages_3d,Popup TogglePager)
#JTL#
changecom(%%%)
MenuAndButtonEntryLM(&Xbiff,xbiff,,Popup ToggleXbiff)
changecom(#)
#JTL#
MenuAndButtonEntryLM(X C&lock,clock,,Popup ToggleXclock)
MenuSeparatorLM
#JTL#MenuAndButtonEntryLM(Fvwm &Command,talk,,FvwmForm TalkForm)
#JTL#MenuAndButtonEntryLM(Reread .&Xdefaults,exclam,,Exec xrdb -merge .Xdefaults)
#JTL#MenuAndButtonEntryLM(Restart &Fvwm2,turn,,Restart fvwm2)
MenuAndButtonEntryLM(Restart &Fvwm2,turn,,Function ReallyRestart)
MenuSeparatorLM
MenuAndButtonEntryLM(Re&fresh Screen,ray,,Refresh)
#JTL#What is Recapture?
MenuAndButtonEntryLM(Re&capture All Windows,recapture,,Recapture)

TraceForErrors(`Window-Ops menu...')

#JTL
ifelse(PLANES, `8', `',`
syscmd(display -window root ANOTHERLEVEL/init-screen-picture-6.jpeg)
')

#
# This defines the most common window operations
#
AddNewMenuAndButtonBar(`Window-Ops')
# Shortcuts: MRAL H/I SXTW DCK BPWUL F
MenuAndButtonEntryLM(&Move,move,icon_move_3d,Function Move-and-Raise)
MenuAndButtonEntryLM(&Resize,resize,,Function Resize-or-Raise)
MenuAndButtonEntryLM(R&aise,raise,hand_up_3d,Raise)
MenuAndButtonEntryLM(&Lower,lower,arrdown_3d,Lower)
MenuAndButtonEntryLM(&ICONIFY_LABEL/Restore,iconify,arrdown2_3d,Iconify)
MenuAndButtonEntryLM(&Stick/Unstick,stick,,Stick)
#JTL#MenuAndButtonEntryLM(Ma&ximize/Reset,,,FullMaximize)
MenuAndButtonEntryLM(Ma&ximize/Reset,maxfull,,FullMaximize)
MenuAndButtonEntryLM(Maximize &Tall/Reset,maxtall,,TallMaximize)
MenuAndButtonEntryLM(Maximize &Wide/Reset,maxwide,,WideMaximize)
MenuSeparatorLM
#JTL# RH6.0 - these no longer work: obsolete modules
#MenuAndButtonEntryLM(Cascad&e,,,FvwmCascade -resize 0 0 80 60)
#MenuAndButtonEntryLM(Tile Hori&zontal,,,FvwmTile -h 0 0 99 90)
#MenuAndButtonEntryLM(Tile &Vertical,,,FvwmTile 0 0 99 90)
##JTL#Replaced with:
ifdef(`RH5', `
MenuAndButtonEntryLM(Cascad&e,cascade,,FvwmCascade -resize 0 0 80 60)
',`
MenuAndButtonEntryLM(Cascad&e,cascade,,FvwmRearrange -cascade -resize 0 0 80 60)
')
ifdef(`RH5', `
MenuAndButtonEntryLM(Tile Hori&zontal,tilehoriz,,FvwmTile -h 0 0 99 90)
',`
MenuAndButtonEntryLM(Tile Hori&zontal,tilehoriz,,FvwmRearrange -tile -h 0 0 99 90)
')
ifdef(`RH5', `
MenuAndButtonEntryLM(Tile &Vertical,tilevert,,FvwmTile 0 0 99 90)
',`
MenuAndButtonEntryLM(Tile &Vertical,tilevert,,FvwmRearrange -tile 0 0 99 90)
')
MenuSeparatorLM
#JTL#What is Delete, Close and Destroy?
#Delete: invite the window to exit gracefully, but it might not.
#Close: invite the window to exit gracefully, but if doesn't, kill it anyway!
#Destroy: just kill it!
MenuAndButtonEntryLM(&Delete,,,Delete)
MenuAndButtonEntryLM(&Close,cross,,Close)
MenuAndButtonEntryLM(&Kill,bomb,bomb_3d,Destroy)
MenuSeparatorLM
MenuAndButtonEntryLM(Scroll&Bar,scroll-arrows,,Module FvwmScroll 2 2)
IfProgramExists(ProgramName(PRINT_FUNCTION),`
MenuAndButtonEntryLM(&Print,,,PrintFunction)
')
MenuAndButtonEntryLM(Capture &Full screen to file,,,Exec xwd -out HOME/full-screen -root)
#JTL#MenuAndButtonEntryLM(Capture &Windows,,,FvwmForm Capture)
MenuAndButtonEntryLM(Capture (&Print) Window,camera,,FvwmForm Capture)
#JTL#Clean seems pointless?
#JTL#MenuAndButtonEntryLM(Clean-&Up Module,pencil,pencil2_3d,Module FvwmClean)
#JTL#Moved to system utilities
#JTL#MenuAndButtonEntryLM(Window &List Module,windows,window3d,Module FvwmWinList)
MenuSeparatorLM
MenuAndButtonEntryLM(Switch to...,,,WindowList)
MenuAndButtonEntryLM(Re&fresh Screen,ray,,Refresh)

# Shortcuts: H/I MSNXCK 
AddToMenu "Window-Ops-Basic" 
+ "&Move MiniTitleIcon(move)"	Move-or-Raise
+ "&Size MiniTitleIcon(resize)" Resize-or-Raise
+ "Mi&nimize MiniTitleIcon(iconify)" Iconify 1
+ "Ma&ximize"       		FullMaximize
+ ""                		Nop
+ "&Close MiniTitleIcon(cross)"	Close
+ "&Kill MiniTitleIcon(bomb)" 	Destroy

TraceForErrors(`Including_fvwm_hostmenus...')
# .fvwm2rc.hostmenus sets up the various menus for working w/ hosts
readFile(`fvwm2rc.hostmenus')
