# AnotherLevelUp/fvwm2rc.xlock.m4
#
# AnotherLevelUp is an fvwm2 configuration package.
# It is based on Red Hat's AnotherLevel.

# AnotherLevelUp started life as a copy of AnotherLevel-0.6.8-2 (default
# in the RH5.1 distribution). Original Red Hat time stamps have been
# updated as later releases of AnotherLevel have been `assimilated' (!) into
# AnotherLevelUp.

# Author John Latham, Dept. CS, University of Manchester, UK
# Email jtl@cs.man.ac.uk
# Licence: GPL
# Copyright (C) John Latham 1999 and Red Hat Software, Inc

# This file is now very different in structure to that of AnotherLevel

divert(-1)
# AnotherLevel - A FVWM2 Configuration
# Copyright (C) 1996, 1997 Red Hat Software, Inc
#
#	$Id: fvwm2rc.xlock.m4,v 1.2 1999/09/23 20:02:58 pbrown Exp $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This work is derived from:
#       TheNextLevel
#       Copyright 1996 By Greg J. Badros <gjb@cs.duke.edu>
# distributed under GNU General Public License.
#
divert

TraceForErrors(`Xlock/Screensaver menus...')

#JTL
#Enable nested forms
define(`XLOCK', XLOCKFORMNAME)

define(`AddXLockOption',`*XLOCK`'Choice	Option $1 off "capitalize($1)"')

*XLOCK`'WarpPointer

#JTL
#Enable nested forms
define(`XLOCK_PRELUDE', `
*XLOCK`'Font		FORM_FONT
*XLOCK`'ButtonFont	FORM_BUTTONFONT
*XLOCK`'InputFont	FORM_INPUTFONT
*XLOCK`'Fore		FORM_FORE
*XLOCK`'Back		FORM_BACK
*XLOCK`'ItemFore	FORM_ITEMFORE
*XLOCK`'ItemBack	FORM_ITEMBACK

*XLOCK`'Line 		center
*XLOCK`'Text 		"Available Xlock modes"
*XLOCK`'Selection		Option single
*XLOCK`'Line 		expand
')

#JTL#This is different and has moved below, to enable nested forms
#esyscmd(`xlock -help 2>&1 | awk "BEGIN{item = 0} \
#		/^$/ {next} \
#		/one of:/ {ok=1; next} \
#		/^[ \t]*[a-z]/ && ok==1 \
#		{ \
#		  if (/random/) { next }; \
#		  if (item == 0) { print \"*XLock`Line	expand\" }; \
#		  printf(\"AddXLockOption(%-10s)\\n\", \$1) ; \
#		  item = (item+1)%5 ; \
#		}"')

#JTL
#Enable nested forms
define(`XLOCK_USERCHOICE', `
# We add the random thing separately, to be sure that we have at least one selected
# option
#JTL# Do not treat random specially, just repeat the user choice at the end of each form
#JTL# if there is one; or repeat random otherwise.
#JTL#*XLockChoice    Option random 	on 	"Random    "
*XLOCK`'Line    left
ifdef(`XLockUserChoice', `
*XLOCK`'Choice Option XLockUserChoice on "capitalize(XLockUserChoice) (Current saved choice)          "
',`
*XLOCK`'Choice Option random on "Random          "
')
')

define(`XLOCK_CONCLUDE', `
#*XLOCK`'Line	expand
#*XLOCK`'Line	expand
#*XLOCK`'Line	expand

#JTL#Is there much point having a manually started screen saver?
#JTL#*XLockButton	quit "Screen Saver"
#JTL#*XLockCommand	Exec xlock -nice NICELEVEL -mode $(Option) -nolock

#JTL#Optional
ifdef(`XLOCKLOCKSCREEN',`
*XLOCK`'Button	quit "Lock Screen"
#JTL#*XLockCommand   Exec xlock -nice NICELEVEL -mode $(Option)
ifdef(`RH5', `
*XLOCK`'Command	Exec xlock -nice NICELEVEL -mode $(Option) -timeelapsed -bg red -enablesaver -mousemotion -timeout 5
', `
*XLOCK`'Command	Exec xlock -nice NICELEVEL -erasemode no_fade -mode $(Option) -timeelapsed -bg red -enablesaver -mousemotion -timeout 5
')
*XLOCK`'Command	Exec test "$(Option)" != "XLockUserChoice" && `echo "define(\`XLockUserChoice', \`$(Option)')" > .fvwm2dir/forms_Xlock'
')

#JTL#Optional
ifdef(`XLOCKBACKGROUND',`
# somebody is gonna hate me for this one... :-)
#JTL#
*XLOCK`'Button	quit "Background"
#JTL#
*XLOCK`'Command	Exec ANOTHERLEVEL/bin/kill-all-proc xlock; "exec" xlock -nice NICELEVEL -mode $(Option) -nolock -inroot -enablesaver
changecom(%%%)
*XLOCK`'Command  Exec ANOTHERLEVEL/bin/save-background-preferences "Moving" "BG_COLOR" "FM_MODE" "BG_BITMAP" $(Option)
changecom(`#')
')

#JTL#
*XLOCK`'Button   continue "Try"
#*XLOCK`'Command Exec ANOTHERLEVEL/bin/kill-all-proc xlock; "exec" xlock -nice NICELEVEL -mode $(Option) -nolock -inroot -enablesaver
#*XLOCK`'Command Exec ANOTHERLEVEL/bin/kill-all-proc xlock; "exec" xlock -nice NICELEVEL -mode $(Option) -nolock -enablesaver -mousemotion
*XLOCK`'Command Exec "exec" xlock -nice NICELEVEL -mode $(Option) -nolock -enablesaver -mousemotion

##JTL#Optional
#ifdef(`XLOCKBACKGROUND',`
##JTL#Lots changed here!
#*XLOCK`'Button	quit "Unbackground (solid)"
#*XLOCK`'Command	Exec ANOTHERLEVEL/bin/kill-all-proc xlock;
#*XLOCK`'Command	Exec xsetroot -solid "BG_COLOR"
#changecom(%%%)
#*XLOCK`'Command  Exec ANOTHERLEVEL/bin/save-background-preferences "Solid" "BG_COLOR" "FM_MODE" "BG_BITMAP" "BG_MOVING"
#changecom(`#')
#')

#JTL#Optional
ifdef(`XLOCKBACKGROUND',`
*XLOCK`'Button	quit "Cancel - Select static"
*XLOCK`'Command	FvwmScript ScreenSetup
')

*XLOCK`'Button	quit "Cancel" ^[
*XLockCommand	Nop
')

esyscmd(`xlock -help 2>&1 \
         | awk "BEGIN{item = 0; thispage = 1; thispagecount = 0} \
		/^$/ {next} \
		/one of:/ {ok=1; next} \
		/^[ \t]*[a-z]/ && ok==1 \
		{ \
                  if (thispagecount == 0)  { print \"XLOCK_PRELUDE\" }; \
		  if (item == 0) { print \"*XLOCK\`'Line	expand\" }; \
		  printf(\"AddXLockOption(%-10s,%s)\\n\", \$1, \$1) ; \
		  item = (item+1)%5 ; \
                  thispagecount = (thispagecount+1) ; \
                  if (thispagecount == 50) \
                    { print \"XLOCK_USERCHOICE\"; \
                      thispagecount = 0 ; \
                      thispage = (thispage+1); \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Button  quit \\\"Next Page\\\"\"; \
                      print \"*XLOCK\`'Command  FvwmForm XLOCKFORMNAME\`'\"thispage; \
                      print \"XLOCK_CONCLUDE\"; \
                      print \"define\(\`XLOCK', XLOCKFORMNAME\`'\"thispage\")\" }; \
		} \
                END { print \"XLOCK_USERCHOICE\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Line	expand\"; \
                      print \"*XLOCK\`'Button  quit \\\"First Page\\\"\"; \
                      print \"*XLOCK\`'Command  FvwmForm XLOCKFORMNAME\"; \
                      print \"XLOCK_CONCLUDE\" }"')

#JTL#This is now removed to the file that called this one
#JTL#so this file can be used to make a moving background menu too
#AddToMenu StartMenu
#+ "Lock Screen / Screen Saver MiniTitleIcon(lock)"	FvwmForm XLock
#+ "" Nop
